# ШАХМАТНАЯ ДОСКА


def setup():
  size(480, 480)
  #size(1000, 1000)
  background(255)
  # размеры клеток:
  global cell_width, cell_height
  cell_width = cell_height = 20
  # шрифт:
  font = createFont('Arial', 20)
  textFont(font)
  # цвета клеток:
  global color1, color2
  color1 = random_color()
  color2 = random_color() 
  # клетки без контуров: 
  noStroke()
  # смещение и размеры шахматной доски:
  global offset_x, offset_y, w, h
  offset_x = offset_y = w = h = 0
  

def draw():
    draw_grid()
    

# ИЗМЕНЯЕМ ЦВЕТ КЛЕТОК
def mousePressed():
  global color1, color2
  color1 = random_color()
  color2 = random_color()  
      

def mouseMoved():
    if not keyPressed:
        return
    global cell_width, cell_height
    global flg_draw
    dx = mouseX - pmouseX
    dy = mouseY - pmouseY   
    #print(dx, dy) 
    fill(255,0,0)
    if dx > 2:
        dx = 1
    elif dx < - 2:
        dx = -1
    else:
        dx = 0
        
    if dy > 2:
        dy = -1
    elif dy < - 2:
        dy = 1
    else:
        dy = 0
   
    new_cell_width = cell_width + dx
    if 1 < new_cell_width <= width:
        cell_width += dx
    
    new_cell_height = cell_height + dy
    if 1 < new_cell_height <= height:       
        cell_height += dy
        
    rect(0,0,width, 30)
    fill(0)
    text(u"Ширина = " + str(cell_width),20,20)
    text(u"Высота = " + str(cell_height),180,20)


# РИСУЕМ ШАХМАТНУЮ ДОСКУ
def draw_grid():
    global offset_x, offset_y, w, h
    # стираем старую доску:
    fill(255)
    rect(offset_x, offset_y, w, h)  
   
    # оставляем сверху место для текста:
    offset_y = 30
    # число колонок:
    col = width // cell_width
    # число строк:
    row = (height - offset_y) // cell_height
    
    # ширина картинки:
    w = col * cell_width
    # высота картинки:
    h = row * cell_height
    # центрируем:
    offset_x = (width - w)/2
    offset_y += (height - offset_y - h)/2
    
    # рисуем клетки:
    for y in range(row):
        for x in range(col): 
            if ((x + y) % 2 == 0):
                clr = color1
            else:
                clr = color2
            fill(clr)
            rect(offset_x + x*cell_width, 
                 offset_y + y*cell_height, 
                 cell_width, cell_height)  
                 

# ВОЗВРАЩАЕМ СЛУЧАЙНЫЙ ЦВЕТ
def random_color():
    clr = color(random(32, 255), random(32, 255), random(32, 255))
    return clr
    