
# ПРОГРАММА ДЛЯ ВЫЧЕРЧИВАНИЯ 
# СЛУЧАЙНЫХ КВАДРАТОВ

# размер клеток в пикселях:
QSIZE = 25
# число клеток по горизонтали:
NCOL = 25
# число клеток по вертикали:
NROW = 25

# толщина линий:
PEN_WIDTH = 1

# цвет фона:
BACKCOLOR = 0

# цвета клеток:
Blue ='#0000FF'
Gold = '#FFD700'
COLORS = [Blue, Gold]

# размеры окна:
WIDTH = (QSIZE + PEN_WIDTH) * NCOL + PEN_WIDTH
HEIGHT = (QSIZE + PEN_WIDTH) * NROW + PEN_WIDTH


def setup():
    # создаём окно:
    size(WIDTH, HEIGHT)
    background(BACKCOLOR)
    drawTable()


# РИСУЕМ ТАБЛИЦУ
def drawTable():
    # число клеток с индексом 0:
    n0 = 0
    
    noStroke()
    # координаты верхнего левого угла первой клетки:
    x1 = PEN_WIDTH
    y1 = PEN_WIDTH
    # чертим таблицу:
    for r in range(NROW):
        for c in range(NCOL):
            # цвет клетки:       
            clr = int(random(2))
            n0 += 1 if clr == 0 else 0
            clr = COLORS[clr]
            # закрашиваем клетку:
            fill(clr)
            rect(x1, y1, QSIZE, QSIZE)
            # координаты верхнего левого угла следующей клетки:
            x1 += QSIZE + PEN_WIDTH
        # переходим на следующую горизонталь:
        x1 = PEN_WIDTH
        y1 += QSIZE + PEN_WIDTH
    
    vsego = NROW * NCOL
    # число клеток с индексом 1:
    n1 = vsego - n0
    print(u"Синих = " + str(n0) + u" : Золотых = " + str(n1))
