
# ПРОГРАММА ДЛЯ ВЫЧЕРЧИВАНИЯ 
# СЛУЧАЙНЫХ КВАДРАТОВ

# размер клеток в пикселях:
QSIZE = 25
# число клеток по горизонтали:
NCOL = 25
# число клеток по вертикали:
NROW = 25

# толщина линий:
PEN_WIDTH = 1

# цвет фона:
BACKCOLOR = 0

# цвета клеток:
Blue ='#0000FF'
Gold = '#FFD700'
COLORS = [Blue, Gold]

# размеры окна:
WIDTH = (QSIZE + PEN_WIDTH) * NCOL + PEN_WIDTH
HEIGHT = (QSIZE + PEN_WIDTH) * NROW + PEN_WIDTH

# число отличных пикселей:
OTL = 3


def setup():
    # создаём окно:
    size(WIDTH + 10 + WIDTH, HEIGHT)
    background(BACKCOLOR)
    createTable()
    drawTable()


# СОЗДАЁМ ТАБЛИЦЫ
def createTable():
    global tableLeft, tableRight, otvet
    tableLeft = createArray(NCOL, NROW)
    tableRight = createArray(NCOL, NROW)

    for r in range(NROW):
        for c in range(NCOL):
            # цвет клетки:       
            clr = int(random(2))
            tableLeft[c][r] = clr
            tableRight[c][r] = clr
    #print(tableLeft)
    # изменяем цвет OTL квадратиков:
    lstRCell = []
    # перекрасили квадратиков:
    n = 0
    # номер случайной клетки:
    rcell = 0
    while (n < OTL):
        while True:
            # выбираем случайную клетку:
            rcell = int(random(0, NCOL * NROW))
            if rcell not in lstRCell:
                break
        lstRCell.append(rcell)
        n += 1

    lstRCell = sorted(lstRCell)
    otvet = u"(Строка, Колонка) --> "
    for i in range(len(lstRCell)):
        # по номерам клеток определяем их координаты:
        cell = lstRCell[i]
        r = int(cell / NCOL)
        c = cell - r * NCOL

        # цвет клетки:
        clr = tableRight[c][r]
        # новый цвет:
        clr = 1 - clr
        tableRight[c][r] = clr
        otvet += "(" + str(r + 1) + "," + str(c + 1) + ") "
    #print(lstRCell)
    #print(otvet)
    

# СОЗДАЁМ ДВУМЕРНЫЙ СПИСОК
def createArray(cols, rows):
    # игровое поле:
    return [[None for row in range(rows)] for col in range(cols)]
    
    
# РИСУЕМ ТАБЛИЦЫ
def drawTable():    
    global tableLeft, tableRight, otvet
    noStroke()
    # координаты верхнего левого угла первой клетки:
    x1 = PEN_WIDTH
    y1 = PEN_WIDTH
    # чертим таблицы:
    for r in range(NROW):
        for c in range(NCOL):
            # цвет клетки:       
            clr = tableLeft[c][r]
            clr = COLORS[clr]
            # закрашиваем клетку:
            fill(clr)
            rect(x1, y1, QSIZE, QSIZE)
            
            # квадратик на второй таблице:  
            clr = tableRight[c][r]
            clr = COLORS[clr]
            fill(clr)
            rect(x1 + 10 + WIDTH, y1, QSIZE, QSIZE)
            # координаты верхнего левого угла следующей клетки:
            x1 += QSIZE + PEN_WIDTH
        # переходим на следующую горизонталь:
        x1 = PEN_WIDTH
        y1 += QSIZE + PEN_WIDTH
    print(otvet)
