# ПРОГРАММА ДЛЯ ВЫЧЕРЧИВАНИЯ 
# ПРОИЗВОЛЬНЫХ ЧЕТЫРЁХУГОЛЬНИКОВ


# размеры окна:
WIDTH = 680
HEIGHT = 550

# радиус кружков:
r = 5
# число кружков:
COUNT = 4
# массив кружков:
verts = [None] * 4


def setup():
    # создаём окно:
    size(WIDTH, HEIGHT)

    background(128)
    # создаём вершины:
    for i in range(COUNT):
        verts[i] = Vertex()
        verts[i].x = random(r, width - r)
        verts[i].y = random(r, height - r)
        verts[i].dx = random(4, 8)
        verts[i].dy = random(4, 8)
        verts[i].clr = random_color()
    frameRate(30)


# РИСУЕМ ЧЕТЫРЁХУГОЛЬНИК
def draw():
    # очищаем канву:
    noStroke()
    fill(255, 20)
    rect(0, 0, width, height)

    # рисуем четырёхугольник:
    strokeWeight(1.5)
    stroke(60)
    fill(255, 255, 0, 60)
    quad(verts[0].x, verts[0].y,
        verts[1].x, verts[1].y,
        verts[2].x, verts[2].y,
        verts[3].x, verts[3].y)

    # рисуем вершины-кружки:
    for i in range(COUNT):
        x = verts[i].x
        y = verts[i].y
        clr = verts[i].clr
        fill(clr)
        ellipse(x, y, r * 2, r * 2)
        verts[i].x += verts[i].dx
        if ((verts[i].x > width - r) or (verts[i].x < r)):
            verts[i].dx = - verts[i].dx
        verts[i].y += verts[i].dy
        if ((verts[i].y > height - r) or (verts[i].y < r)):
            verts[i].dy = - verts[i].dy


# КЛАСС ВЕРШИНЫ:
class Vertex():
    # координаты:
    x = y = 0
    # цвет:
    clr = 0
    # перемещение:
    dx = dy = 0
    
    
# ВОЗВРАЩАЕМ СЛУЧАЙНЫЙ ЦВЕТ
def random_color(a = 255):
    clr = color(random(0,255), random(0, 255), random(0, 255), a)
    return clr
