# ПРОГРАММА ДЛЯ ВЫЧЕРЧИВАНИЯ 
# ДУГ ЭЛЛИПСА


# размеры окна:
WIDTH = 680
HEIGHT = 550

COUNT = 7
arcs = [None] * COUNT


def setup():
    # создаём окно:
    size(WIDTH, HEIGHT)
    # размер текста:
    textSize(24)

    #создаём дуги:
    for i in range(COUNT):
        arcs[i] = Sector()

        arcs[i].w = random(120, 250)
        arcs[i].h = random(120, 260)
        arcs[i].x = random(arcs[i].w / 2, width - arcs[i].w / 2)
        arcs[i].y = random(arcs[i].h / 2, height - arcs[i].h / 2)
        arcs[i].clr = random_color(5)
        arcs[i].startAngle = 0
        arcs[i].stopAngle = random(360)
        arcs[i].dAngle = random(1, 3)


# РИСУЕМ ДУГИ
def draw():
    # очищаем экран:
    noStroke()
    fill(228, 3)
    rect(0, 0, width, height)
    #return

    # чертим дуги:
    strokeWeight(1)
    stroke(90)
    for i in range(COUNT):
        # углы:
        beg = arcs[i].startAngle
        end = arcs[i].stopAngle
        x = arcs[i].x
        y = arcs[i].y
        w = arcs[i].w
        h = arcs[i].h
        clr = arcs[i].clr
        fill(clr)
        arc(x, y, w, h,
            radians(beg),
            radians(end))
        arcs[i].stopAngle += arcs[i].dAngle
        arcs[i].stopAngle %= 360


# ВОЗВРАЩАЕМ СЛУЧАЙНЫЙ ЦВЕТ
def random_color(a = 255):
    clr = color(random(0,255), random(0, 255), random(0, 255), a)
    return clr


# КЛАСС СЕКТОРА
class Sector():
    # координаты и размеры дуги:
    x = y = w = h = 0
    # цвет:
    clr = 0
    # начальный угол:
    startAngle = 0
    # конечный угол:
    stopAngle = 0
    # приращение конечного угла:
    dAngle = 0
